Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IOperatorGraph.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IOperatorGraph.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IOperatorGraph.cs	(revision 2033)
@@ -45,14 +45,8 @@
     void AddOperator(IOperator op);
     /// <summary>
-    /// Removes an operator with the specified <paramref name="guid"/> from the current instance.
+    /// Removes an operator from the current instance.
     /// </summary>
-    /// <param name="guid">The unique id of the operator to remove.</param>
-    void RemoveOperator(Guid guid);
-    /// <summary>
-    /// Gets the operator with the specified <paramref name="guid"/>.
-    /// </summary>
-    /// <param name="guid">The unique id of the operator.</param>
-    /// <returns>The searched operator.</returns>
-    IOperator GetOperator(Guid guid);
+    /// <param name="op">The operator that should be removed.</param>
+    void RemoveOperator(IOperator op);
     /// <summary>
     /// Clears the current instance.
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IOperatorGroup.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IOperatorGroup.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IOperatorGroup.cs	(revision 2033)
@@ -29,5 +29,5 @@
   /// Interface to represent a group of operators.
   /// </summary>
-  public interface IOperatorGroup : IStorable {
+  public interface IOperatorGroup : ICloneable {
     /// <summary>
     /// Gets or sets the name of the current instance.
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IParameter.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IParameter.cs	(revision 2033)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IParameter.cs	(revision 2033)
@@ -0,0 +1,33 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+
+namespace HeuristicLab.Core {
+  public interface IParameter : IItem {
+    string Name { get; }
+    string Description { get; }
+    Type DataType { get; }
+    ParamterType Type { get; }
+  }
+}
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IScope.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IScope.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IScope.cs	(revision 2033)
@@ -129,10 +129,4 @@
     void ReorderSubScopes(int[] sequence);
     /// <summary>
-    /// Gets the sub scope with the given <paramref name="guid"/>.
-    /// </summary>
-    /// <param name="guid">The unique identifier of the sub scope.</param>
-    /// <returns>The sub scope with the given <paramref name="guid"/>.</returns>
-    IScope GetScope(Guid guid);
-    /// <summary>
     /// Gets the sub scope with the given <paramref name="name"/>.
     /// </summary>
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IViewable.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IViewable.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Interfaces/IViewable.cs	(revision 2033)
@@ -34,4 +34,13 @@
     /// <returns>The created view.</returns>
     IView CreateView();
+
+    /// <summary>
+    /// Fires a new <c>Changed</c> event.
+    /// </summary>
+    void FireChanged();
+    /// <summary>
+    /// Occurs when the current instance has changed.
+    /// </summary>
+    event EventHandler Changed;
   }
 }
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ItemBase.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ItemBase.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/ItemBase.cs	(revision 2033)
@@ -31,5 +31,5 @@
   /// </summary>
   [EmptyStorableClass]
-  public abstract class ItemBase : StorableBase, IItem {
+  public abstract class ItemBase : CloneableBase, IItem {
     /// <summary>
     /// Creates a new instance of <see cref="ItemBaseView"/> for 
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorBase.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorBase.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorBase.cs	(revision 2033)
@@ -30,5 +30,5 @@
   /// The base class for all operators.
   /// </summary>
-  public abstract class OperatorBase : ConstrainedItemBase, IOperator {
+  public abstract class OperatorBase : ItemBase, IOperator {
 
     [Storable]
@@ -130,5 +130,5 @@
     /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
     /// <returns>The cloned object as <see cref="OperatorBase"/>.</returns>
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+    public override object Clone(IDictionary<long, object> clonedObjects) {
       OperatorBase clone = (OperatorBase)base.Clone(clonedObjects);
       clone.myName = Name;
@@ -162,31 +162,4 @@
       OnSubOperatorAdded(subOperator, mySubOperators.Count - 1);
     }
-    /// <inheritdoc cref="IOperator.TryAddSubOperator(HeuristicLab.Core.IOperator)"/>
-    /// <param name="subOperator">The sub operator to add.</param>
-    /// <remarks>Calls <see cref="OnSubOperatorAdded"/>.</remarks>
-    public virtual bool TryAddSubOperator(IOperator subOperator) {
-      mySubOperators.Add(subOperator);
-      if (IsValid()) {
-        OnSubOperatorAdded(subOperator, mySubOperators.Count - 1);
-        return true;
-      } else {
-        mySubOperators.RemoveAt(mySubOperators.Count - 1);
-        return false;
-      }
-    }
-    /// <inheritdoc cref="HeuristicLab.Core.IOperator.TryAddSubOperator(HeuristicLab.Core.IOperator, 
-    /// out System.Collections.Generic.ICollection&lt;HeuristicLab.Core.IConstraint&gt;)"/>
-    /// <param name="subOperator">The sub operator to add.</param>
-    /// <remarks>Calls <see cref="OnSubOperatorAdded"/>.</remarks>
-    public virtual bool TryAddSubOperator(IOperator subOperator, out ICollection<IConstraint> violatedConstraints) {
-      mySubOperators.Add(subOperator);
-      if (IsValid(out violatedConstraints)) {
-        OnSubOperatorAdded(subOperator, mySubOperators.Count - 1);
-        return true;
-      } else {
-        mySubOperators.RemoveAt(mySubOperators.Count - 1);
-        return false;
-      }
-    }
     /// <inheritdoc cref="HeuristicLab.Core.IOperator.AddSubOperator(HeuristicLab.Core.IOperator, int)"/>
     /// <param name="subOperator">The sub operator to add.</param>
@@ -196,31 +169,4 @@
       OnSubOperatorAdded(subOperator, index);
     }
-    /// <inheritdoc cref="IOperator.TryAddSubOperator(HeuristicLab.Core.IOperator, int)"/>
-    /// <param name="subOperator">The sub operator to add.</param>
-    /// <remarks>Calls <see cref="OnSubOperatorAdded"/>.</remarks>
-    public virtual bool TryAddSubOperator(IOperator subOperator, int index) {
-      mySubOperators.Insert(index, subOperator);
-      if (IsValid()) {
-        OnSubOperatorAdded(subOperator, index);
-        return true;
-      } else {
-        mySubOperators.RemoveAt(index);
-        return false;
-      }
-    }
-    /// <inheritdoc cref="IOperator.TryAddSubOperator(HeuristicLab.Core.IOperator, int, out
-    /// System.Collections.Generic.ICollection&lt;HeuristicLab.Core.IConstraint&gt;)"/>
-    /// <param name="subOperator">The sub operator to add.</param>
-    /// <remarks>Calls <see cref="OnSubOperatorAdded"/>.</remarks>
-    public virtual bool TryAddSubOperator(IOperator subOperator, int index, out ICollection<IConstraint> violatedConstraints) {
-      mySubOperators.Insert(index, subOperator);
-      if (IsValid(out violatedConstraints)) {
-        OnSubOperatorAdded(subOperator, index);
-        return true;
-      } else {
-        mySubOperators.RemoveAt(index);
-        return false;
-      }
-    }
     /// <inheritdoc/>
     /// <remarks>Calls <see cref="OnSubOperatorRemoved"/>.</remarks>
@@ -229,30 +175,4 @@
       mySubOperators.RemoveAt(index);
       OnSubOperatorRemoved(op, index);
-    }
-    /// <inheritdoc/>
-    /// <remarks>Calls <see cref="OnSubOperatorRemoved"/>.</remarks>
-    public virtual bool TryRemoveSubOperator(int index) {
-      IOperator op = mySubOperators[index];
-      mySubOperators.RemoveAt(index);
-      if (IsValid()) {
-        OnSubOperatorRemoved(op, index);
-        return true;
-      } else {
-        mySubOperators.Insert(index, op);
-        return false;
-      }
-    }
-    /// <inheritdoc/>
-    /// <remarks>Calls <see cref="OnSubOperatorRemoved"/>.</remarks>
-    public virtual bool TryRemoveSubOperator(int index, out ICollection<IConstraint> violatedConstraints) {
-      IOperator op = mySubOperators[index];
-      mySubOperators.RemoveAt(index);
-      if (IsValid(out violatedConstraints)) {
-        OnSubOperatorRemoved(op, index);
-        return true;
-      } else {
-        mySubOperators.Insert(index, op);
-        return false;
-      }
     }
     #endregion
@@ -274,28 +194,4 @@
     }
     /// <inheritdoc/>
-    /// <remarks>Calls <see cref="OnVariableInfoAdded"/>.</remarks>
-    public virtual bool TryAddVariableInfo(IVariableInfo variableInfo) {
-      myVariableInfos.Add(variableInfo.FormalName, variableInfo);
-      if (IsValid()) {
-        OnVariableInfoAdded(variableInfo);
-        return true;
-      } else {
-        myVariableInfos.Remove(variableInfo.FormalName);
-        return false;
-      }
-    }
-    /// <inheritdoc/>
-    /// <remarks>Calls <see cref="OnVariableInfoAdded"/>.</remarks>
-    public virtual bool TryAddVariableInfo(IVariableInfo variableInfo, out ICollection<IConstraint> violatedConstraints) {
-      myVariableInfos.Add(variableInfo.FormalName, variableInfo);
-      if (IsValid(out violatedConstraints)) {
-        OnVariableInfoAdded(variableInfo);
-        return true;
-      } else {
-        myVariableInfos.Remove(variableInfo.FormalName);
-        return false;
-      }
-    }
-    /// <inheritdoc/>
     /// <remarks>Calls <see cref="OnVariableInfoRemoved"/>.</remarks>
     public virtual void RemoveVariableInfo(string formalName) {
@@ -305,37 +201,4 @@
         OnVariableInfoRemoved(variableInfo);
       }
-    }
-    /// <inheritdoc/>
-    /// <remarks>Calls <see cref="OnVariableInfoRemoved"/>.</remarks>
-    public virtual bool TryRemoveVariableInfo(string formalName) {
-      IVariableInfo variableInfo;
-      if (myVariableInfos.TryGetValue(formalName, out variableInfo)) {
-        myVariableInfos.Remove(formalName);
-        if (IsValid()) {
-          OnVariableInfoRemoved(variableInfo);
-          return true;
-        } else {
-          myVariableInfos.Add(formalName, variableInfo);
-          return false;
-        }
-      }
-      return true;
-    }
-    /// <inheritdoc/>
-    /// <remarks>Calls <see cref="OnVariableInfoRemoved"/>.</remarks>
-    public virtual bool TryRemoveVariableInfo(string formalName, out ICollection<IConstraint> violatedConstraints) {
-      IVariableInfo variableInfo;
-      if (myVariableInfos.TryGetValue(formalName, out variableInfo)) {
-        myVariableInfos.Remove(formalName);
-        if (IsValid(out violatedConstraints)) {
-          OnVariableInfoRemoved(variableInfo);
-          return true;
-        } else {
-          myVariableInfos.Add(formalName, variableInfo);
-          return false;
-        }
-      }
-      violatedConstraints = new List<IConstraint>();
-      return true;
     }
     #endregion
@@ -358,34 +221,4 @@
       variable.NameChanged += new EventHandler(Variable_NameChanged);
       OnVariableAdded(variable);
-    }
-    /// <inheritdoc/>
-    /// <remarks>Calls <see cref="OnVariableAdded"/> and adds <c>NameChanging</c> and <c>NameChanged</c>
-    /// event handlers.</remarks>
-    public virtual bool TryAddVariable(IVariable variable) {
-      myVariables.Add(variable.Name, variable);
-      if (IsValid()) {
-        variable.NameChanging += new EventHandler<NameChangingEventArgs>(Variable_NameChanging);
-        variable.NameChanged += new EventHandler(Variable_NameChanged);
-        OnVariableAdded(variable);
-        return true;
-      } else {
-        myVariableInfos.Remove(variable.Name);
-        return false;
-      }
-    }
-    /// <inheritdoc/>
-    /// <remarks>Calls <see cref="OnVariableAdded"/> and adds <c>NameChanging</c> and <c>NameChanged</c>
-    /// event handlers.</remarks>
-    public virtual bool TryAddVariable(IVariable variable, out ICollection<IConstraint> violatedConstraints) {
-      myVariables.Add(variable.Name, variable);
-      if (IsValid(out violatedConstraints)) {
-        variable.NameChanging += new EventHandler<NameChangingEventArgs>(Variable_NameChanging);
-        variable.NameChanged += new EventHandler(Variable_NameChanged);
-        OnVariableAdded(variable);
-        return true;
-      } else {
-        myVariableInfos.Remove(variable.Name);
-        return false;
-      }
     }
     /// <inheritdoc/>
@@ -400,43 +233,4 @@
         OnVariableRemoved(variable);
       }
-    }
-    /// <inheritdoc/>
-    /// <remarks>Calls <see cref="OnVariableRemoved"/> and removes <c>NameChanging</c> and <c>NameChanged</c>
-    /// event handlers.</remarks>
-    public virtual bool TryRemoveVariable(string name) {
-      IVariable variable;
-      if (myVariables.TryGetValue(name, out variable)) {
-        myVariables.Remove(name);
-        if (IsValid()) {
-          variable.NameChanging -= new EventHandler<NameChangingEventArgs>(Variable_NameChanging);
-          variable.NameChanged -= new EventHandler(Variable_NameChanged);
-          OnVariableRemoved(variable);
-          return true;
-        } else {
-          myVariables.Add(name, variable);
-          return false;
-        }
-      }
-      return true;
-    }
-    /// <inheritdoc/>
-    /// <remarks>Calls <see cref="OnVariableRemoved"/> and removes <c>NameChanging</c> and <c>NameChanged</c>
-    /// event handlers.</remarks>
-    public virtual bool TryRemoveVariable(string name, out ICollection<IConstraint> violatedConstraints) {
-      IVariable variable;
-      if (myVariables.TryGetValue(name, out variable)) {
-        myVariables.Remove(name);
-        if (IsValid(out violatedConstraints)) {
-          variable.NameChanging -= new EventHandler<NameChangingEventArgs>(Variable_NameChanging);
-          variable.NameChanged -= new EventHandler(Variable_NameChanged);
-          OnVariableRemoved(variable);
-          return true;
-        } else {
-          myVariables.Add(name, variable);
-          return false;
-        }
-      }
-      violatedConstraints = new List<IConstraint>();
-      return true;
     }
     private void Variable_NameChanging(object sender, NameChangingEventArgs e) {
@@ -489,4 +283,5 @@
     }
     #endregion
+
     /// <inheritdoc/>
     public virtual IOperation Execute(IScope scope) {
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorBaseView.Designer.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorBaseView.Designer.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorBaseView.Designer.cs	(revision 2033)
@@ -54,5 +54,4 @@
       this.operatorBaseVariablesView = new HeuristicLab.Core.OperatorBaseVariablesView();
       this.constraintsTabPage = new System.Windows.Forms.TabPage();
-      this.constrainedItemBaseView = new HeuristicLab.Core.ConstrainedItemBaseView();
       this.descriptionTabPage = new System.Windows.Forms.TabPage();
       this.operatorBaseDescriptionView = new HeuristicLab.Core.OperatorBaseDescriptionView();
@@ -121,5 +120,4 @@
       // constraintsTabPage
       // 
-      this.constraintsTabPage.Controls.Add(this.constrainedItemBaseView);
       this.constraintsTabPage.Location = new System.Drawing.Point(4, 22);
       this.constraintsTabPage.Name = "constraintsTabPage";
@@ -129,14 +127,4 @@
       this.constraintsTabPage.Text = "Constraints";
       this.constraintsTabPage.UseVisualStyleBackColor = true;
-      // 
-      // constrainedItemBaseView
-      // 
-      this.constrainedItemBaseView.Caption = "Constrained Data";
-      this.constrainedItemBaseView.ConstrainedItem = null;
-      this.constrainedItemBaseView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.constrainedItemBaseView.Location = new System.Drawing.Point(3, 3);
-      this.constrainedItemBaseView.Name = "constrainedItemBaseView";
-      this.constrainedItemBaseView.Size = new System.Drawing.Size(409, 301);
-      this.constrainedItemBaseView.TabIndex = 0;
       // 
       // descriptionTabPage
@@ -184,5 +172,4 @@
     protected TabPage variablesTabPage;
     private TabPage constraintsTabPage;
-    protected ConstrainedItemBaseView constrainedItemBaseView;
     protected OperatorBaseVariableInfosView operatorBaseVariableInfosView;
     protected OperatorBaseVariablesView operatorBaseVariablesView;
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorBaseView.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorBaseView.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorBaseView.cs	(revision 2033)
@@ -68,5 +68,4 @@
       operatorBaseVariableInfosView.Operator = null;
       operatorBaseVariablesView.Operator = null;
-      constrainedItemBaseView.ConstrainedItem = null;
       operatorBaseDescriptionView.Operator = null;
       base.RemoveItemEvents();
@@ -79,5 +78,4 @@
       operatorBaseVariableInfosView.Operator = Operator;
       operatorBaseVariablesView.Operator = Operator;
-      constrainedItemBaseView.ConstrainedItem = Operator;
       operatorBaseDescriptionView.Operator = Operator;
     }
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorGraph.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorGraph.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorGraph.cs	(revision 2033)
@@ -33,10 +33,10 @@
 
     [Storable]
-    private IDictionary<Guid, IOperator> myOperators;
+    private IList<IOperator> myOperators;
     /// <summary>
     /// Gets all operators of the current instance.
     /// </summary>
     public ICollection<IOperator> Operators {
-      get { return myOperators.Values; }
+      get { return myOperators; }
     }
 
@@ -61,5 +61,5 @@
     /// </summary>
     public OperatorGraph() {
-      myOperators = new Dictionary<Guid, IOperator>();
+      myOperators = new List<IOperator>();
     }
 
@@ -80,7 +80,7 @@
     /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
     /// <returns>The cloned object as <see cref="OperatorGraph"/>.</returns>
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+    public override object Clone(IDictionary<long, object> clonedObjects) {
       OperatorGraph clone = new OperatorGraph();
-      clonedObjects.Add(Guid, clone);
+      clonedObjects.Add(clone.Id, clone);
       foreach (IOperator op in Operators)
         clone.AddOperator((IOperator)Auxiliary.Clone(op, clonedObjects));
@@ -93,6 +93,6 @@
     /// <remarks>Calls <see cref="OnOperatorAdded"/>.</remarks>
     public void AddOperator(IOperator op) {
-      if (!myOperators.ContainsKey(op.Guid)) {
-        myOperators.Add(op.Guid, op);
+      if (!myOperators.Contains(op)) {
+        myOperators.Add(op);
         OnOperatorAdded(op);
 
@@ -103,7 +103,6 @@
     /// <inheritdoc/>
     /// <remarks>Calls <see cref="OnOperatorRemoved"/>.</remarks>
-    public void RemoveOperator(Guid guid) {
-      IOperator op = GetOperator(guid);
-      if (op != null) {
+    public void RemoveOperator(IOperator op) {
+      if (Operators.Contains(op)) {
         foreach (IOperator o in Operators) {
           int i = 0;
@@ -117,26 +116,12 @@
         if (InitialOperator == op)
           InitialOperator = null;
-        myOperators.Remove(op.Guid);
+        myOperators.Remove(op);
         OnOperatorRemoved(op);
       }
     }
     /// <inheritdoc/>
-    public IOperator GetOperator(Guid guid) {
-      IOperator op;
-      if (myOperators.TryGetValue(guid, out op))
-        return op;
-      else
-        return null;
-    }
-    /// <inheritdoc/>
     public void Clear() {
-      Guid[] guids = new Guid[Operators.Count];
-      int i = 0;
-      foreach (IOperator op in Operators) {
-        guids[i] = op.Guid;
-        i++;
-      }
-      for (int j = 0; j < guids.Length; j++)
-        RemoveOperator(guids[j]);
+      while (myOperators.Count > 0)
+        RemoveOperator(myOperators[0]);
     }
 
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorGraphView.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorGraphView.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorGraphView.cs	(revision 2033)
@@ -218,5 +218,5 @@
         if (operatorsListView.SelectedItems.Count > 0) {
           foreach (ListViewItem item in operatorsListView.SelectedItems)
-            OperatorGraph.RemoveOperator(((IOperator)item.Tag).Guid);
+            OperatorGraph.RemoveOperator((IOperator)item.Tag);
         }
       }
@@ -258,5 +258,5 @@
       if (operatorsListView.SelectedItems.Count > 0) {
         foreach (ListViewItem item in operatorsListView.SelectedItems)
-          OperatorGraph.RemoveOperator(((IOperator)item.Tag).Guid);
+          OperatorGraph.RemoveOperator((IOperator)item.Tag);
       }
     }
@@ -350,37 +350,13 @@
               IOperator newParent = (IOperator)node.Parent.Tag;
               int newIndex = node.Index;
-              ICollection<IConstraint> violatedConstraints;
-              ICollection<IConstraint> violatedConstraints2;
-              oldParent.TryRemoveSubOperator(oldIndex, out violatedConstraints);
-              newParent.TryAddSubOperator(op, newIndex, out violatedConstraints2);
-              if ((violatedConstraints.Count == 0) && (violatedConstraints2.Count == 0)) {
-                graphTreeView.SelectedNode = parentNode.Nodes[newIndex];
-              } else {
-                List<IConstraint> allViolatedConstraints = new List<IConstraint>(violatedConstraints);
-                allViolatedConstraints.AddRange(violatedConstraints2);
-                if (Auxiliary.ShowIgnoreConstraintViolationMessageBox(allViolatedConstraints) == DialogResult.Yes) {
-                  if (violatedConstraints.Count > 0)
-                    oldParent.RemoveSubOperator(oldIndex);
-                  if (violatedConstraints2.Count > 0)
-                    newParent.AddSubOperator(op, newIndex);
-                  graphTreeView.SelectedNode = parentNode.Nodes[newIndex];
-                } else {
-                  if (violatedConstraints.Count == 0)
-                    oldParent.AddSubOperator(op, oldIndex);
-                  if (violatedConstraints2.Count == 0)
-                    newParent.RemoveSubOperator(newIndex);
-                }
-              }
+              oldParent.RemoveSubOperator(oldIndex);
+              newParent.AddSubOperator(op, newIndex);
+              graphTreeView.SelectedNode = parentNode.Nodes[newIndex];
             }
           } else {
             if (node != null) {
               IOperator parent = (IOperator)node.Tag;
-              ICollection<IConstraint> violatedConstraints;
-              if (parent.TryAddSubOperator(op, out violatedConstraints)) {
-                graphTreeView.SelectedNode = node.Nodes[node.Nodes.Count - 1];
-              } else if (Auxiliary.ShowIgnoreConstraintViolationMessageBox(violatedConstraints) == DialogResult.Yes) {
-                parent.AddSubOperator(op);
-                graphTreeView.SelectedNode = node.Nodes[node.Nodes.Count - 1];
-              }
+              parent.AddSubOperator(op);
+              graphTreeView.SelectedNode = node.Nodes[node.Nodes.Count - 1];
             }
           }
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorGroup.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorGroup.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorGroup.cs	(revision 2033)
@@ -30,5 +30,5 @@
   /// Representation of a group of operators (can also include subgroups).
   /// </summary>
-  public class OperatorGroup : StorableBase, IOperatorGroup {
+  public class OperatorGroup : CloneableBase, IOperatorGroup {
 
     [Storable]
@@ -84,5 +84,5 @@
     /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
     /// <returns>The cloned object as <see cref="OperatorGroup"/>.</returns>
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+    public override object Clone(IDictionary<long, object> clonedObjects) {
       OperatorGroup clone = (OperatorGroup)base.Clone(clonedObjects);
       clone.myName = Name;
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorLibrary.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorLibrary.cs	(revision 2032)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/OperatorLibrary.cs	(revision 2033)
@@ -70,7 +70,7 @@
     /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
     /// <returns>The cloned object as <see cref="OperatorLibrary"/>.</returns>
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+    public override object Clone(IDictionary<long, object> clonedObjects) {
       OperatorLibrary clone = new OperatorLibrary();
-      clonedObjects.Add(Guid, clone);
+      clonedObjects.Add(clone.Id, clone);
       clone.myGroup = (IOperatorGroup)Auxiliary.Clone(Group, clonedObjects);
       return clone;
Index: /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Parameter.cs
===================================================================
--- /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Parameter.cs	(revision 2033)
+++ /branches/Operator Architecture Refactoring/HeuristicLab.Core/3.3/Parameter.cs	(revision 2033)
@@ -0,0 +1,81 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Core {
+  public class Parameter : ItemBase, IParameter {
+    [Storable]
+    private string myName;
+    public string Name {
+      get { return myName; }
+    }
+
+    [Storable]
+    private string myDescription;
+    public string Description {
+      get { return myDescription; }
+    }
+
+    [Storable]
+    private Type myDataType;
+    public Type DataType {
+      get { return myDataType; }
+    }
+
+    [Storable]
+    private ParamterType myType;
+    public ParamterType Type {
+      get { return myType; }
+    }
+
+    public Parameter() {
+      myName = "Anonymous";
+      myDescription = "";
+      myDataType = null;
+      myType = ParamterType.In;
+    }
+    public Parameter(string name, string description, Type dataType, ParamterType type)
+      : this() {
+      myName = name;
+      myDescription = description;
+      myDataType = dataType;
+      myType = type;
+    }
+
+    public override IView CreateView() {
+      return new ParameterView(this);
+    }
+
+    public override object Clone(IDictionary<long, object> clonedObjects) {
+      Parameter clone = new Parameter();
+      clonedObjects.Add(clone.Id, clone);
+      clone.myName = Name;
+      clone.myDescription = Description;
+      clone.myDataType = DataType;
+      clone.myType = Type;
+      return clone;
+    }
+  }
+}
